LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_signed.all;

ENTITY accumulate IS
	GENERIC( LEN : natural);
	PORT(clock : in std_logic;
		  reset : in std_logic;
		  enable : in std_logic;
		  input: in std_logic_vector(LEN-1 downto 0); 
		  output: out std_logic_vector(LEN-1 downto 0));
END ENTITY;

ARCHITECTURE behav OF accumulate is
BEGIN
   process (clock, reset)
		constant zero : STD_LOGIC_VECTOR(LEN-1 DOWNTO 0)  := (others=> '0');
		variable acc : std_logic_vector(LEN-1 downto 0) :=  zero;	
	begin
		if reset='1' then
			acc:= zero;
			output <= acc;
		elsif (rising_edge(clock)) then
			if (enable='1') then
				acc := acc+input;
				output <= acc;
			end if;
		end if;
	end process;
END ARCHITECTURE;