LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY fifo IS
	GENERIC( N : natural; LEN : natural);
	PORT(clock : in std_logic;
		  reset : in std_logic;
		  enable : in std_logic;
		  input: in std_logic_vector(LEN-1 downto 0); 
		  output: out std_logic_vector(LEN-1 downto 0));
END ENTITY;

ARCHITECTURE behav OF fifo is
BEGIN
   process (clock, reset)
	   TYPE Buffer_Type is array (0 to N-1) of STD_LOGIC_VECTOR(LEN-1 DOWNTO 0);
		constant zero : STD_LOGIC_VECTOR(LEN-1 DOWNTO 0)  := (others=> '0');
	   variable buff : Buffer_Type := (others=> zero);
	begin
		if reset='1' then
			buff:= (others=> zero);
		elsif (rising_edge(clock)) then
			if (enable='1') then
				output <= buff(N-1);
				buff(1 to N-1) := buff(0 to N-2);
				buff(0):=input;
			end if;
		end if;
	end process;
END ARCHITECTURE;